var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};
(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "./utils"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var utils_1 = require("./utils");
    var digitReducer = function (_a) {
        var value = _a.value, result = _a.result, posValue = _a.posValue;
        var q = Math.floor(value / posValue);
        return {
            value: value - q * posValue,
            posValue: posValue / 20,
            result: __spreadArrays(result, [utils_1.valueToDigit(q)])
        };
    };
    var encodeAxis = function (length, value) {
        return utils_1.arrayOf(length, null).reduce(digitReducer, { value: value, posValue: 20, result: [] }).result;
    };
    var interleave = function (length) { return function (xs, ys) {
        var zipped = utils_1.zip(xs, ys);
        var padding = length > 8 ? [] : utils_1.arrayOf(8 - length, '0');
        var digits = __spreadArrays(utils_1.flatten(zipped), padding);
        return __spreadArrays(digits.slice(0, 8), ['+'], digits.slice(8)).join('');
    }; };
    var normalizeLatitude = function (lat) { return Math.min(180, Math.max(0, lat + 90)); };
    var normalizeLongitude = function (lon) { return (lon + 180) % 360; };
    var encode = function (coordinates, length) {
        if (length === void 0) { length = 10; }
        if (length < 2 || length > 10 || length % 2 !== 0)
            return null;
        if (!utils_1.isValidCoordinates(coordinates))
            return null;
        var latitude = normalizeLatitude(utils_1.parseNum(coordinates.latitude));
        var longitude = normalizeLongitude(utils_1.parseNum(coordinates.longitude));
        return interleave(length)(encodeAxis(length / 2, latitude), encodeAxis(length / 2, longitude));
    };
    exports.default = encode;
});
//# sourceMappingURL=encode.js.map