(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var digits = '23456789CFGHJMPQRVWX';
    var pair = "[" + digits + "]{2}";
    var pairOrZero = "([" + digits + "]|0){2}";
    var regexp = "^" + pair + "(" + pairOrZero + "){0,3}[+](" + pair + ")?$";
    exports.isValidCoordinates = function (subject) {
        if (subject == null || typeof subject !== 'object')
            return false;
        return 'longitude' in subject && 'latitude' in subject;
    };
    exports.isValidCode = function (subject) {
        return typeof subject === 'string' && Boolean(subject.match(regexp));
    };
    exports.digitToValue = function (x) { return digits.indexOf(x); };
    exports.valueToDigit = function (x) { return digits.charAt(x); };
    exports.parseNum = function (value) {
        return typeof value === 'string' ? parseFloat(value) : value;
    };
    exports.arrayOf = function (count, fill) {
        var result = [];
        for (var i = 0; i < count; i++)
            result.push(fill);
        return result;
    };
    exports.flatten = function (a) { return a.reduce(function (acc, val) { return acc.concat(val); }, []); };
    exports.zip = function (a, b) { return a.map(function (e, i) { return [e, b[i]]; }); };
});
//# sourceMappingURL=utils.js.map